diff --git a/src/main/java/net/minecraft/core/net/command/arguments/AchievementArgumentType.java b/src/main/java/net/minecraft/core/net/command/arguments/AchievementArgumentType.java
new file mode 100644
index 000000000..2308ab8a3
--- /dev/null
+++ b/src/main/java/net/minecraft/core/net/command/arguments/AchievementArgumentType.java
@@ -0,0 +1,52 @@
+package net.minecraft.core.net.command.arguments;
+
+import com.mojang.brigadier.StringReader;
+import com.mojang.brigadier.arguments.ArgumentType;
+import com.mojang.brigadier.context.CommandContext;
+import com.mojang.brigadier.exceptions.CommandSyntaxException;
+import com.mojang.brigadier.suggestion.Suggestions;
+import com.mojang.brigadier.suggestion.SuggestionsBuilder;
+import net.minecraft.core.achievement.Achievement;
+import net.minecraft.core.achievement.Achievements;
+import net.minecraft.core.lang.I18n;
+import net.minecraft.core.net.command.util.CommandHelper;
+
+import java.util.Arrays;
+import java.util.Collection;
+import java.util.Optional;
+import java.util.concurrent.CompletableFuture;
+
+public class AchievementArgumentType implements ArgumentType<Achievement> {
+    private static final Collection<String> EXAMPLES = Arrays.asList("achievement.acquireIron", "acquireIron");
+
+    public static ArgumentType<Achievement> achievement() {
+        return new AchievementArgumentType();
+    }
+
+    @Override
+    public Achievement parse(StringReader reader) throws CommandSyntaxException {
+        final String string = reader.readString();
+
+        for (Achievement achievement : Achievements.achievementList) {
+            if (CommandHelper.matchesKeyString(achievement.getStatKey(), string)) {
+                return achievement;
+            }
+        }
+        throw new CommandSyntaxException(CommandSyntaxException.BUILT_IN_EXCEPTIONS.dispatcherUnknownArgument(), () -> I18n.getInstance().translateKey("command.argument_types.achievement.invalid_achievement"));
+    }
+
+    @Override
+    public <S> CompletableFuture<Suggestions> listSuggestions(final CommandContext<S> context, final SuggestionsBuilder builder) {
+        String remaining = builder.getRemainingLowerCase();
+        for (Achievement achievement : Achievements.achievementList) {
+            Optional<String> optional = CommandHelper.getStringToSuggest(achievement.getStatKey(), remaining);
+            optional.ifPresent(builder::suggest);
+        }
+        return builder.buildFuture();
+    }
+
+    @Override
+    public Collection<String> getExamples() {
+        return EXAMPLES;
+    }
+}
diff --git a/src/main/java/net/minecraft/core/net/command/arguments/BiomeArgumentType.java b/src/main/java/net/minecraft/core/net/command/arguments/BiomeArgumentType.java
new file mode 100644
index 000000000..f2eb235fa
--- /dev/null
+++ b/src/main/java/net/minecraft/core/net/command/arguments/BiomeArgumentType.java
@@ -0,0 +1,67 @@
+package net.minecraft.core.net.command.arguments;
+
+import com.mojang.brigadier.StringReader;
+import com.mojang.brigadier.arguments.ArgumentType;
+import com.mojang.brigadier.context.CommandContext;
+import com.mojang.brigadier.exceptions.CommandSyntaxException;
+import com.mojang.brigadier.suggestion.Suggestions;
+import com.mojang.brigadier.suggestion.SuggestionsBuilder;
+import net.minecraft.core.data.registry.Registries;
+import net.minecraft.core.lang.I18n;
+import net.minecraft.core.net.command.util.CommandHelper;
+import net.minecraft.core.world.biome.Biome;
+
+import java.util.Arrays;
+import java.util.Collection;
+import java.util.Optional;
+import java.util.concurrent.CompletableFuture;
+
+public class BiomeArgumentType implements ArgumentType<Biome> {
+    private static final Collection<String> EXAMPLES = Arrays.asList("overworld", "nether");
+
+    public static BiomeArgumentType biome() {
+        return new BiomeArgumentType();
+    }
+
+    @Override
+    public Biome parse(StringReader reader) throws CommandSyntaxException {
+        final String string = readResourceLocation(reader);
+
+        for (Biome biome : Registries.BIOMES) {
+            if (CommandHelper.matchesKeyString(Registries.BIOMES.getKey(biome), string)) {
+                return biome;
+            }
+        }
+        throw new CommandSyntaxException(CommandSyntaxException.BUILT_IN_EXCEPTIONS.dispatcherUnknownArgument(), () -> I18n.getInstance().translateKey("command.argument_types.biome.invalid_biome"));
+    }
+
+    public String readResourceLocation(StringReader reader) {
+        if (!reader.canRead()) {
+            return "";
+        }
+        final int start = reader.getCursor();
+        while (reader.canRead() && isAllowedInResourceLocation(reader.peek())) {
+            reader.skip();
+        }
+        return reader.getString().substring(start, reader.getCursor());
+    }
+
+    public static boolean isAllowedInResourceLocation(char c) {
+        return c >= '0' && c <= '9' || c >= 'a' && c <= 'z' || c == '_' || c == ':' || c == '/' || c == '.' || c == '-';
+    }
+
+    @Override
+    public <S> CompletableFuture<Suggestions> listSuggestions(CommandContext<S> context, SuggestionsBuilder builder) {
+        String remaining = builder.getRemainingLowerCase();
+        for (Biome biome : Registries.BIOMES) {
+            Optional<String> optional = CommandHelper.getStringToSuggest(Registries.BIOMES.getKey(biome), remaining);
+            optional.ifPresent(builder::suggest);
+        }
+        return builder.buildFuture();
+    }
+
+    @Override
+    public Collection<String> getExamples() {
+        return EXAMPLES;
+    }
+}
\ No newline at end of file
diff --git a/src/main/java/net/minecraft/core/net/command/arguments/BlockArgumentType.java b/src/main/java/net/minecraft/core/net/command/arguments/BlockArgumentType.java
new file mode 100644
index 000000000..6d2518474
--- /dev/null
+++ b/src/main/java/net/minecraft/core/net/command/arguments/BlockArgumentType.java
@@ -0,0 +1,56 @@
+package net.minecraft.core.net.command.arguments;
+
+import com.mojang.brigadier.StringReader;
+import com.mojang.brigadier.arguments.ArgumentType;
+import com.mojang.brigadier.context.CommandContext;
+import com.mojang.brigadier.exceptions.CommandSyntaxException;
+import com.mojang.brigadier.suggestion.Suggestions;
+import com.mojang.brigadier.suggestion.SuggestionsBuilder;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.net.command.helpers.BlockArgumentParser;
+import net.minecraft.core.net.command.helpers.BlockInput;
+import net.minecraft.core.net.command.util.CommandHelper;
+
+import java.util.Arrays;
+import java.util.Collection;
+import java.util.List;
+import java.util.Locale;
+import java.util.concurrent.CompletableFuture;
+
+public class BlockArgumentType implements ArgumentType<BlockInput> {
+    private static final List<String> EXAMPLES = Arrays.asList("tile.stone", "stone", "tile.log[1]");
+
+    public static ArgumentType<BlockInput> block() {
+        return new BlockArgumentType();
+    }
+
+    @Override
+    public BlockInput parse(StringReader reader) throws CommandSyntaxException {
+        BlockArgumentParser parser = new BlockArgumentParser(reader);
+        return parser.parse();
+    }
+
+    @Override
+    public <S> CompletableFuture<Suggestions> listSuggestions(CommandContext<S> context, SuggestionsBuilder builder) {
+        StringReader stringReader = new StringReader(builder.getInput());
+        stringReader.setCursor(builder.getStart());
+        BlockArgumentParser parser = new BlockArgumentParser(stringReader);
+        try {
+            parser.parse();
+        } catch (CommandSyntaxException ignored) {}
+        return parser.fillSuggestions(builder, suggestionsBuilder -> {
+            String remaining = suggestionsBuilder.getRemaining().toLowerCase(Locale.ROOT);
+            for (Block block : Block.blocksList) {
+                if (block == null) continue;
+                CommandHelper.getStringToSuggest(block.getKey(), remaining).ifPresent(suggestionsBuilder::suggest);
+                CommandHelper.getStringToSuggest("tile.air", remaining).ifPresent(suggestionsBuilder::suggest);
+            }
+            suggestionsBuilder.buildFuture();
+        });
+    }
+
+    @Override
+    public Collection<String> getExamples() {
+        return EXAMPLES;
+    }
+}
diff --git a/src/main/java/net/minecraft/core/net/command/arguments/ChunkCoordinatesArgumentType.java b/src/main/java/net/minecraft/core/net/command/arguments/ChunkCoordinatesArgumentType.java
new file mode 100644
index 000000000..4ab680257
--- /dev/null
+++ b/src/main/java/net/minecraft/core/net/command/arguments/ChunkCoordinatesArgumentType.java
@@ -0,0 +1,88 @@
+package net.minecraft.core.net.command.arguments;
+
+import com.mojang.brigadier.StringReader;
+import com.mojang.brigadier.arguments.ArgumentType;
+import com.mojang.brigadier.context.CommandContext;
+import com.mojang.brigadier.exceptions.CommandSyntaxException;
+import com.mojang.brigadier.suggestion.Suggestions;
+import com.mojang.brigadier.suggestion.SuggestionsBuilder;
+import net.minecraft.core.net.command.CommandSource;
+import net.minecraft.core.net.command.exceptions.CommandExceptions;
+import net.minecraft.core.net.command.helpers.Coordinates2D;
+import net.minecraft.core.net.command.helpers.IntegerCoordinate;
+import net.minecraft.core.util.helper.MathHelper;
+import net.minecraft.core.util.phys.Vec3;
+
+import java.util.Arrays;
+import java.util.Collection;
+import java.util.List;
+import java.util.concurrent.CompletableFuture;
+
+public class ChunkCoordinatesArgumentType implements ArgumentType<Coordinates2D> {
+    private static final List<String> EXAMPLES = Arrays.asList("~ ~", "0 0 0", "~60 ~", "~-20 -25");
+
+    public static ChunkCoordinatesArgumentType chunkCoordinates() {
+        return new ChunkCoordinatesArgumentType();
+    }
+
+    @Override
+    public Coordinates2D parse(StringReader reader) throws CommandSyntaxException {
+        int i = reader.getCursor();
+        IntegerCoordinate x = IntegerCoordinate.parse(reader);
+        if (!reader.canRead() || reader.peek() != ' ') {
+            if (reader.peek() == 'f' || reader.peek() == 'd') {
+                reader.skip();
+                if (!reader.canRead() || reader.peek() != ' ') {
+                    reader.setCursor(i);
+                    throw CommandExceptions.incomplete().createWithContext(reader);
+                }
+            } else {
+                reader.setCursor(i);
+                throw CommandExceptions.incomplete().createWithContext(reader);
+            }
+        }
+        reader.skip();
+        IntegerCoordinate z = IntegerCoordinate.parse(reader);
+        return new Coordinates2D(x, z);
+    }
+
+    @Override
+    public <S> CompletableFuture<Suggestions> listSuggestions(CommandContext<S> context, SuggestionsBuilder builder) {
+        String string = builder.getRemaining();
+        Vec3 coordinates = ((CommandSource)context.getSource()).getBlockCoordinates();
+
+        if (coordinates == null) return builder.buildFuture();
+
+        int[] roundedCoordinates = new int[]{
+                MathHelper.floor(coordinates.x / 16.0),
+                MathHelper.floor(coordinates.z / 16.0)
+        };
+
+        if (string.isEmpty()) {
+            String allCoordinates = roundedCoordinates[0] + " " + roundedCoordinates[1];
+            try {
+                this.parse(new StringReader(allCoordinates));
+                builder.suggest(String.valueOf(roundedCoordinates[0]));
+                builder.suggest(roundedCoordinates[0] + " " + roundedCoordinates[1]);
+                builder.suggest(allCoordinates);
+            } catch (CommandSyntaxException ignored) {}
+        } else {
+            String[] strings = string.split(" ");
+            String allCoordinates;
+            if (strings.length == 1) {
+                allCoordinates = strings[0] + " " + roundedCoordinates[1];
+                try {
+                    this.parse(new StringReader(allCoordinates));
+                    builder.suggest(strings[0] + " " + roundedCoordinates[1]);
+                    builder.suggest(allCoordinates);
+                } catch (CommandSyntaxException ignored) {}
+            }
+        }
+        return builder.buildFuture();
+    }
+
+    @Override
+    public Collection<String> getExamples() {
+        return EXAMPLES;
+    }
+}
diff --git a/src/main/java/net/minecraft/core/net/command/arguments/DamageTypeArgumentType.java b/src/main/java/net/minecraft/core/net/command/arguments/DamageTypeArgumentType.java
new file mode 100644
index 000000000..8454fe8d2
--- /dev/null
+++ b/src/main/java/net/minecraft/core/net/command/arguments/DamageTypeArgumentType.java
@@ -0,0 +1,51 @@
+package net.minecraft.core.net.command.arguments;
+
+import com.mojang.brigadier.StringReader;
+import com.mojang.brigadier.arguments.ArgumentType;
+import com.mojang.brigadier.context.CommandContext;
+import com.mojang.brigadier.exceptions.CommandSyntaxException;
+import com.mojang.brigadier.suggestion.Suggestions;
+import com.mojang.brigadier.suggestion.SuggestionsBuilder;
+import net.minecraft.core.lang.I18n;
+import net.minecraft.core.net.command.util.CommandHelper;
+import net.minecraft.core.util.helper.DamageType;
+
+import java.util.Arrays;
+import java.util.Collection;
+import java.util.Optional;
+import java.util.concurrent.CompletableFuture;
+
+public class DamageTypeArgumentType implements ArgumentType<DamageType> {
+    private static final Collection<String> EXAMPLES = Arrays.asList("damagetype.combat", "damagetype.blast");
+
+    public static DamageTypeArgumentType damageType() {
+        return new DamageTypeArgumentType();
+    }
+
+    @Override
+    public DamageType parse(StringReader reader) throws CommandSyntaxException {
+        final String string = reader.readString();
+
+        for (DamageType damageType : DamageType.values()) {
+            if (CommandHelper.matchesKeyString(damageType.getLanguageKey(), string)) {
+                return damageType;
+            }
+        }
+        throw new CommandSyntaxException(CommandSyntaxException.BUILT_IN_EXCEPTIONS.dispatcherUnknownArgument(), () -> I18n.getInstance().translateKey("command.argument_types.damage_type.invalid_damage_type"));
+    }
+
+    @Override
+    public <S> CompletableFuture<Suggestions> listSuggestions(final CommandContext<S> context, final SuggestionsBuilder builder) {
+        String remaining = builder.getRemainingLowerCase();
+        for (DamageType damageType : DamageType.values()) {
+            Optional<String> optional = CommandHelper.getStringToSuggest(damageType.getLanguageKey(), remaining);
+            optional.ifPresent(builder::suggest);
+        }
+        return builder.buildFuture();
+    }
+
+    @Override
+    public Collection<String> getExamples() {
+        return EXAMPLES;
+    }
+}
diff --git a/src/main/java/net/minecraft/core/net/command/arguments/DimensionArgumentType.java b/src/main/java/net/minecraft/core/net/command/arguments/DimensionArgumentType.java
new file mode 100644
index 000000000..7667e1779
--- /dev/null
+++ b/src/main/java/net/minecraft/core/net/command/arguments/DimensionArgumentType.java
@@ -0,0 +1,52 @@
+package net.minecraft.core.net.command.arguments;
+
+import com.mojang.brigadier.StringReader;
+import com.mojang.brigadier.arguments.ArgumentType;
+import com.mojang.brigadier.context.CommandContext;
+import com.mojang.brigadier.exceptions.CommandSyntaxException;
+import com.mojang.brigadier.suggestion.Suggestions;
+import com.mojang.brigadier.suggestion.SuggestionsBuilder;
+import net.minecraft.core.lang.I18n;
+import net.minecraft.core.net.command.util.CommandHelper;
+import net.minecraft.core.world.Dimension;
+
+import java.util.Arrays;
+import java.util.Collection;
+import java.util.Map;
+import java.util.Optional;
+import java.util.concurrent.CompletableFuture;
+
+public class DimensionArgumentType implements ArgumentType<Dimension> {
+    private static final Collection<String> EXAMPLES = Arrays.asList("overworld", "nether");
+
+    public static DimensionArgumentType dimension() {
+        return new DimensionArgumentType();
+    }
+
+    @Override
+    public Dimension parse(StringReader reader) throws CommandSyntaxException {
+        final String string = reader.readString();
+
+        for (Map.Entry<Integer, Dimension> dimension : Dimension.getDimensionList().entrySet()) {
+            if (CommandHelper.matchesKeyString(dimension.getValue().languageKey, string) || string.equals(String.valueOf(dimension.getKey()))) {
+                return dimension.getValue();
+            }
+        }
+        throw new CommandSyntaxException(CommandSyntaxException.BUILT_IN_EXCEPTIONS.dispatcherUnknownArgument(), () -> I18n.getInstance().translateKey("command.argument_types.dimension.invalid_dimension"));
+    }
+
+    @Override
+    public <S> CompletableFuture<Suggestions> listSuggestions(CommandContext<S> context, SuggestionsBuilder builder) {
+        String remaining = builder.getRemainingLowerCase();
+        for (Dimension dimension : Dimension.getDimensionList().values()) {
+            Optional<String> optional = CommandHelper.getStringToSuggest(dimension.languageKey, remaining);
+            optional.ifPresent(builder::suggest);
+        }
+        return builder.buildFuture();
+    }
+
+    @Override
+    public Collection<String> getExamples() {
+        return EXAMPLES;
+    }
+}
\ No newline at end of file
diff --git a/src/main/java/net/minecraft/core/net/command/arguments/EntityArgumentType.java b/src/main/java/net/minecraft/core/net/command/arguments/EntityArgumentType.java
new file mode 100644
index 000000000..6bd8e6da8
--- /dev/null
+++ b/src/main/java/net/minecraft/core/net/command/arguments/EntityArgumentType.java
@@ -0,0 +1,89 @@
+package net.minecraft.core.net.command.arguments;
+
+import com.mojang.brigadier.StringReader;
+import com.mojang.brigadier.arguments.ArgumentType;
+import com.mojang.brigadier.context.CommandContext;
+import com.mojang.brigadier.exceptions.CommandSyntaxException;
+import com.mojang.brigadier.suggestion.Suggestions;
+import com.mojang.brigadier.suggestion.SuggestionsBuilder;
+import net.minecraft.core.net.command.CommandSource;
+import net.minecraft.core.net.command.exceptions.CommandExceptions;
+import net.minecraft.core.net.command.helpers.EntitySelector;
+import net.minecraft.core.net.command.helpers.EntitySelectorParser;
+import net.minecraft.core.net.command.util.CommandHelper;
+import net.minecraft.core.net.command.util.ConcatIterable;
+
+import java.util.Arrays;
+import java.util.Collection;
+import java.util.concurrent.CompletableFuture;
+
+public class EntityArgumentType implements ArgumentType<EntitySelector> {
+    private static final Collection<String> EXAMPLES = Arrays.asList("Player", "0123", "@e", "@e[type=foo]", EntitySelector.ENTITY_PREFIX + "11203");
+
+    private final boolean singleEntity, playerOnly;
+
+    private EntityArgumentType(boolean singleEntity, boolean playerOnly) {
+        this.singleEntity = singleEntity;
+        this.playerOnly = playerOnly;
+    }
+
+    public static EntityArgumentType entities() {
+        return new EntityArgumentType(false, false);
+    }
+
+    public static EntityArgumentType entity() {
+        return new EntityArgumentType(true, false);
+    }
+
+    public static EntityArgumentType players() {
+        return new EntityArgumentType(false, true);
+    }
+
+    public static EntityArgumentType player() {
+        return new EntityArgumentType(true, true);
+    }
+
+    @Override
+    public EntitySelector parse(StringReader reader) throws CommandSyntaxException {
+        int cursor = reader.getCursor();
+        EntitySelectorParser entitySelectorParser = new EntitySelectorParser(reader);
+        EntitySelector entitySelector = entitySelectorParser.parse();
+        if (this.singleEntity && entitySelector.getMaxResults() > 1) {
+            reader.setCursor(cursor);
+            if (this.playerOnly) {
+                throw CommandExceptions.singlePlayerOnly().createWithContext(reader);
+            }
+            throw CommandExceptions.singleEntityOnly().createWithContext(reader);
+        }
+        if (this.playerOnly && entitySelector.includesEntities() && !entitySelector.isCurrentEntity()) {
+            reader.setCursor(cursor);
+            throw CommandExceptions.playerOnly().createWithContext(reader);
+        }
+        return entitySelector;
+    }
+
+    @Override
+    public <S> CompletableFuture<Suggestions> listSuggestions(CommandContext<S> context, SuggestionsBuilder builder) {
+        S s = context.getSource();
+        if (s instanceof CommandSource) {
+            CommandSource source = (CommandSource)s;
+            StringReader stringReader = new StringReader(builder.getInput());
+            stringReader.setCursor(builder.getStart());
+            EntitySelectorParser entitySelectorParser = new EntitySelectorParser(stringReader, source.hasAdmin());
+            try {
+                entitySelectorParser.parse();
+            } catch (CommandSyntaxException ignored) {}
+            return entitySelectorParser.fillSuggestions(builder, suggestionsBuilder -> {
+                Collection<String> collection = source.getPlayerNames();
+                Iterable<String> iterable = this.playerOnly ? collection : new ConcatIterable<>(collection, source.getEntitySuggestions());
+                CommandHelper.suggest(iterable, suggestionsBuilder);
+            });
+        }
+        return Suggestions.empty();
+    }
+
+    @Override
+    public Collection<String> getExamples() {
+        return EXAMPLES;
+    }
+}
diff --git a/src/main/java/net/minecraft/core/net/command/arguments/EntitySummonArgumentType.java b/src/main/java/net/minecraft/core/net/command/arguments/EntitySummonArgumentType.java
new file mode 100644
index 000000000..2033a84c2
--- /dev/null
+++ b/src/main/java/net/minecraft/core/net/command/arguments/EntitySummonArgumentType.java
@@ -0,0 +1,51 @@
+package net.minecraft.core.net.command.arguments;
+
+import com.mojang.brigadier.StringReader;
+import com.mojang.brigadier.arguments.ArgumentType;
+import com.mojang.brigadier.context.CommandContext;
+import com.mojang.brigadier.exceptions.CommandSyntaxException;
+import com.mojang.brigadier.suggestion.Suggestions;
+import com.mojang.brigadier.suggestion.SuggestionsBuilder;
+import net.minecraft.core.entity.Entity;
+import net.minecraft.core.entity.EntityDispatcher;
+import net.minecraft.core.lang.I18n;
+
+import java.util.Arrays;
+import java.util.Collection;
+import java.util.List;
+import java.util.concurrent.CompletableFuture;
+
+public class EntitySummonArgumentType implements ArgumentType<Class<? extends Entity>> {
+    private static final List<String> EXAMPLES = Arrays.asList("Creeper", "Skeleton", "Slime");
+
+    public static ArgumentType<Class<? extends Entity>> entity() {
+        return new EntitySummonArgumentType();
+    }
+
+    @Override
+    public Class<? extends Entity> parse(StringReader reader) throws CommandSyntaxException {
+        final String string = reader.readString();
+
+        for (String entityName : EntityDispatcher.keyToClassMap.keySet()) {
+            if (entityName.equals(string)) {
+                return EntityDispatcher.keyToClassMap.get(entityName);
+            }
+        }
+        throw new CommandSyntaxException(CommandSyntaxException.BUILT_IN_EXCEPTIONS.dispatcherUnknownArgument(), () -> I18n.getInstance().translateKey("command.argument_types.entity_summon.invalid_entity"));
+    }
+
+    @Override
+    public <S> CompletableFuture<Suggestions> listSuggestions(CommandContext<S> context, SuggestionsBuilder builder) {
+        for (String entityName : EntityDispatcher.keyToClassMap.keySet()) {
+            if (entityName.toLowerCase().startsWith(builder.getRemainingLowerCase())) {
+                builder.suggest(entityName);
+            }
+        }
+        return builder.buildFuture();
+    }
+
+    @Override
+    public Collection<String> getExamples() {
+        return EXAMPLES;
+    }
+}
diff --git a/src/main/java/net/minecraft/core/net/command/arguments/GameModeArgumentType.java b/src/main/java/net/minecraft/core/net/command/arguments/GameModeArgumentType.java
new file mode 100644
index 000000000..247a5cc2d
--- /dev/null
+++ b/src/main/java/net/minecraft/core/net/command/arguments/GameModeArgumentType.java
@@ -0,0 +1,51 @@
+package net.minecraft.core.net.command.arguments;
+
+import com.mojang.brigadier.StringReader;
+import com.mojang.brigadier.arguments.ArgumentType;
+import com.mojang.brigadier.context.CommandContext;
+import com.mojang.brigadier.exceptions.CommandSyntaxException;
+import com.mojang.brigadier.suggestion.Suggestions;
+import com.mojang.brigadier.suggestion.SuggestionsBuilder;
+import net.minecraft.core.lang.I18n;
+import net.minecraft.core.net.command.util.CommandHelper;
+import net.minecraft.core.player.gamemode.Gamemode;
+
+import java.util.Arrays;
+import java.util.Collection;
+import java.util.Optional;
+import java.util.concurrent.CompletableFuture;
+
+public class GameModeArgumentType implements ArgumentType<Gamemode> {
+    private static final Collection<String> EXAMPLES = Arrays.asList(Gamemode.creative.getLanguageKey(), Gamemode.survival.getLanguageKey());
+
+    public static ArgumentType<Gamemode> gameMode() {
+        return new GameModeArgumentType();
+    }
+
+    @Override
+    public Gamemode parse(StringReader reader) throws CommandSyntaxException {
+        final String string = reader.readString();
+
+        for (Gamemode gamemode : Gamemode.gamemodesList) {
+            if (CommandHelper.matchesKeyString(gamemode.getLanguageKey(), string) || string.equals(String.valueOf(gamemode.getId()))) {
+                return gamemode;
+            }
+        }
+        throw new CommandSyntaxException(CommandSyntaxException.BUILT_IN_EXCEPTIONS.dispatcherUnknownArgument(), () -> I18n.getInstance().translateKey("command.argument_types.game_mode.invalid_game_mode"));
+    }
+
+    @Override
+    public <S> CompletableFuture<Suggestions> listSuggestions(CommandContext<S> context, SuggestionsBuilder builder) {
+        String remaining = builder.getRemainingLowerCase();
+        for (Gamemode gamemode : Gamemode.gamemodesList) {
+            Optional<String> optional = CommandHelper.getStringToSuggest(gamemode.getLanguageKey(), remaining);
+            optional.ifPresent(builder::suggest);
+        }
+        return builder.buildFuture();
+    }
+
+    @Override
+    public Collection<String> getExamples() {
+        return EXAMPLES;
+    }
+}
diff --git a/src/main/java/net/minecraft/core/net/command/arguments/GenericGameRuleArgumentType.java b/src/main/java/net/minecraft/core/net/command/arguments/GenericGameRuleArgumentType.java
new file mode 100644
index 000000000..fc9d36aef
--- /dev/null
+++ b/src/main/java/net/minecraft/core/net/command/arguments/GenericGameRuleArgumentType.java
@@ -0,0 +1,44 @@
+package net.minecraft.core.net.command.arguments;
+
+import com.mojang.brigadier.StringReader;
+import com.mojang.brigadier.arguments.ArgumentType;
+import com.mojang.brigadier.context.CommandContext;
+import com.mojang.brigadier.exceptions.CommandSyntaxException;
+import com.mojang.brigadier.exceptions.SimpleCommandExceptionType;
+import com.mojang.brigadier.suggestion.Suggestions;
+import com.mojang.brigadier.suggestion.SuggestionsBuilder;
+import net.minecraft.core.data.gamerule.GameRule;
+import net.minecraft.core.lang.I18n;
+
+import java.util.concurrent.CompletableFuture;
+
+public class GenericGameRuleArgumentType implements ArgumentType<Object> {
+    private final GameRule<?> gameRule;
+    private static final SimpleCommandExceptionType FAILURE = new SimpleCommandExceptionType(() -> I18n.getInstance().translateKey("command.argument_types.gamerule.invalid_value"));
+
+    private GenericGameRuleArgumentType(GameRule<?> gameRule) {
+        this.gameRule = gameRule;
+    }
+
+    public static GenericGameRuleArgumentType gameRule(GameRule<?> gameRule) {
+        return new GenericGameRuleArgumentType(gameRule);
+    }
+
+    @Override
+    public Object parse(StringReader reader) throws CommandSyntaxException {
+        StringBuilder read = new StringBuilder();
+        Object value = null;
+        while (reader.canRead() && (StringReader.isQuotedStringStart(reader.peek()) || StringReader.isAllowedInUnquotedString(reader.peek())) && value == null) {
+            read.append(reader.readString());
+            value = this.gameRule.parseFromString(read.toString());
+        }
+
+        if (value != null) return value;
+        throw FAILURE.create();
+    }
+
+    @Override
+    public <S> CompletableFuture<Suggestions> listSuggestions(CommandContext<S> context, SuggestionsBuilder builder) {
+        return ArgumentType.super.listSuggestions(context, builder);
+    }
+}
